| Earth Observation Mission CFI Software Pointing Software User Manual |

Public Member Functions | Protected Member Functions

# EECFI::InstrTransId Class Reference

Class for storing the Instrument Attitude configuration parameters. More...

Inheritance diagram for EECFI::InstrTransId:

List of all members.

## Public Member Functions
| InstrTransId ()
| Empty Class constructor.
| ~InstrTransId () throw (CfiError)
| Class destructor.
void | init (const double angle[3], const double offsets[3]) throw (CfiError)
| Initialise using angles.
void | init (const double matrix[3][3], const double offsets[3]) throw (CfiError)
| Initialise using matrix.
void | init (long angleType, const vector< long > &harmTypePitch, const vector< long > &harmTypeRoll, const vector< long > &harmTypeYaw, const vector< double > &harmCoeffPitch, const vector< double > &harmCoeffRoll, const vector< double > &harmCoeffYaw, double offsets[3]) throw (CfiError)
| Initialise instrument attitude mispointing angles for a given satellite with a user-provided set of values.
void | init (const TimeCorrelation &timeId, const vector< string > &files, long timeInitMode, long timeRef, double time0, double time1) throw (CfiError)
| Initialise satellite attitude angles for a given satellite reading values from the attitude files.
MatrixModel | getMatrix () const throw (CfiError)
| Get matrix model.
void | setMatrix (const MatrixModel &matrixModel) throw (CfiError)
| Change matrix model.
AngleModel | getAngles () const throw (CfiError)
| Get angles model.
void | setAngles (const AngleModel &angleModel) throw (CfiError)
| Change angles model.
HarmonicModel | getHarmonic () const throw (CfiError)
| Get harmonic parameters of object.
void | setHarmonic (const HarmonicModel &harmModel) throw (CfiError)
| Change harmonic parameters of the object.
AttFileModel | getFile () const throw (CfiError)
| Get file data of object.
void | setFile (const AttFileModel &fileModel) throw (CfiError)
| Change initialisation file data of the object.
void | getOffset (double offset[3]) const throw (CfiError)
| Get Instrument frame origin position vector (Satellite attitude frame).
void | setOffset (const double offset[3]) throw (CfiError)
| Change Instrument frame origin position vector (Satellite attitude frame).
void | setAzElDefinition (const AzElDefinition &azElDef) throw (CfiError)
| Set azimuth/elevation definition.
SatId | satId () const
| Return satellite id.
## Protected Member Functions
GenericId * | getId ()
| Get the id.
void | eraseObject () throw (CfiError)
| Erase object and free memory.

## Detailed Description

Class for storing the Instrument Attitude configuration parameters.

## Constructor & Destructor Documentation

EECFI::InstrTransId::InstrTransId | ( |  | ) |

Empty Class constructor.

EECFI::InstrTransId::~InstrTransId | ( |  | ) | throw (CfiError)

Class destructor.

References eraseObject().

## Member Function Documentation

void EECFI::InstrTransId::eraseObject | ( |  | ) | throw (CfiError)`[protected]`

Erase object and free memory.

References EECFI::CfiId::status(), EECFI::CfiId::subtractInstance(), and EECFI::CfiClass::throwWarn.

Referenced by ~InstrTransId().

AngleModel EECFI::InstrTransId::getAngles | ( |  | ) | const throw (CfiError)

Get angles model.

Returns:
  Angle model data.

References EECFI::CfiError::addMsg(), EECFI::AngleModel::angles, and EECFI::CfiClass::throwWarn.

AttFileModel EECFI::InstrTransId::getFile | ( |  | ) | const throw (CfiError)

Get file data of object.

Returns:
  File model data.

References EECFI::CfiError::addMsg(), EECFI::AttFileModel::attData, EECFI::AttFileModel::dataType, EECFI::AttFileModel::fileModel, EECFI::AttFileModel::inertialFrame, EECFI::AttFileModel::maxGap, EECFI::CfiClass::throwWarn, EECFI::AttFileModel::valTime0, and EECFI::AttFileModel::valTime1.

HarmonicModel EECFI::InstrTransId::getHarmonic | ( |  | ) | const throw (CfiError)

Get harmonic parameters of object.

Returns:
  Harmonic model data.

References EECFI::CfiError::addMsg(), EECFI::HarmonicModel::angleType, EECFI::HarmonicData::harmonicCoeffPitch, EECFI::HarmonicData::harmonicCoeffRoll, EECFI::HarmonicData::harmonicCoeffYaw, EECFI::HarmonicModel::harmonicData, EECFI::HarmonicData::harmonicTypePitch, EECFI::HarmonicData::harmonicTypeRoll, EECFI::HarmonicData::harmonicTypeYaw, and EECFI::CfiClass::throwWarn.

GenericId * EECFI::InstrTransId::getId | ( |  | ) | `[protected]`

Get the id.

Returns:
  Pointer to xp_instr_trans_id.

MatrixModel EECFI::InstrTransId::getMatrix | ( |  | ) | const throw (CfiError)

Get matrix model.

Returns:
  Matrix model data.

References EECFI::CfiError::addMsg(), EECFI::MatrixModel::attMatrix, and EECFI::CfiClass::throwWarn.

void EECFI::InstrTransId::getOffset | ( | double | offset[3] | ) | const throw (CfiError)

Get Instrument frame origin position vector (Satellite attitude frame).

Parameters:

  | offset | [OUTPUT] Instrument frame origin position vector - Satellite attitude frame-.

References EECFI::CfiError::addMsg().

void EECFI::InstrTransId::init | ( | const double | angle[3],
|  | const double | offset[3] |
| ) |  |  | throw (CfiError)

Initialise using angles.

Parameters:

  | angle | Rotation angles. [0]: Pitch mispointing angle (Satellite Nominal Attitude Frame) [deg]. Allowed range: If no better value, assume 0.0. [1]: Roll mispointing angle (Satellite Nominal Attitude Frame) [deg]. Allowed range: If no better value, assume 0.0. [2]: Yaw mispointing angle (Satellite Nominal Attitude Frame) [deg]. Allowed range: If no better value, assume 0.0. .
  | offset | Instrument Frame Origin position vector (Satellite attitude frame) [m].

void EECFI::InstrTransId::init | ( | const TimeCorrelation & | timeId,
|  | const vector< string > & | files,
|  | long | timeInitMode,
|  | long | timeRef,
|  | double | time0,
|  | double | time1 |
| ) |  |  | throw (CfiError)

Initialise satellite attitude angles for a given satellite reading values from the attitude files.

In order to read files, this method internally uses Data Handling functions. Please refer to [D_H_SUM] for further details.

Parameters:

  | timeId | Time correlations.
  | files | Filenames of the reference data files. In case multiple files are used, the files should be time ordered. The supported Attitude File format is the Generic Attitude File as described in [DAT_SUM].
  | timeInitMode | Flag for selecting the time range of the initialisation (XPCFI_SEL_TIME/XPCFI_SEL_FILE).
  | timeRef | Time reference (TimeRefPointingEnum).
  | time0 | Start of the time range [Decimal days (Processing format)].
  | time1 | Stop of the time range [Decimal days (Processing format)].

void EECFI::InstrTransId::init | ( | const double | matrix[3][3],
|  | const double | offset[3] |
| ) |  |  | throw (CfiError)

Initialise using matrix.

Parameters:

  | matrix | Rotation matrix.
  | offset | Instrument Frame Origin position vector (Satellite attitude frame) [m].

void EECFI::InstrTransId::init | ( | long | angleType,
|  | const vector< long > & | harmTypePitch,
|  | const vector< long > & | harmTypeRoll,
|  | const vector< long > & | harmTypeYaw,
|  | const vector< double > & | harmCoefPitch,
|  | const vector< double > & | harmCoefRoll,
|  | const vector< double > & | harmCoefYaw,
|  | double | offset[3] |
| ) |  |  | throw (CfiError)

Initialise instrument attitude mispointing angles for a given satellite with a user-provided set of values.

The Attitude::compute and Attitude::changeFrame functions will then compute the values as follows:

Parameters:

  | angleType | Type of angle (given by PointingAngleTypeEnum).
  | harmTypePitch | Type of coefficients: 0= for the bias parameter <0 for the sinus coefficients (-n means that corresponds to the sinus coefficient of order n) >0 for the cosinus coefficients (-n means that corresponds to the cosinus coefficient of order n) .
  | harmTypeRoll | Type of coefficients (bias, sinus, cosinus).
  | harmTypeYaw | Type of coefficients (bias, sinus, cosinus).
  | harmCoefPitch | Bias, sinus and cosinus coefficients for the pitch angle.
  | harmCoefRoll | Bias, sinus and cosinus coefficients for the roll angle.
  | harmCoefYaw | Bias, sinus and cosinus coefficients for the yaw angle.
  | offset | Instrument Frame Origin position vector (Satellite attitude frame) [m].

References EECFI::CfiError::addMsg().

SatId EECFI::InstrTransId::satId | ( |  | ) | const

Return satellite id.

Returns:
  Satellite id.

void EECFI::InstrTransId::setAngles | ( | const AngleModel & | angleModel | ) | throw (CfiError)

Change angles model.

Parameters:

  | angleModel | Angle model data.

References EECFI::CfiError::addMsg().

void EECFI::InstrTransId::setAzElDefinition | ( | const AzElDefinition & | azElDef | ) | throw (CfiError)

Set azimuth/elevation definition.

Parameters:

  | azElDef | Definition of azimuth and elevation.

void EECFI::InstrTransId::setFile | ( | const AttFileModel & | fileModel | ) | throw (CfiError)

Change initialisation file data of the object.

Returns:
  fileModel File model data.

References EECFI::CfiError::addMsg().

void EECFI::InstrTransId::setHarmonic | ( | const HarmonicModel & | harmonicModel | ) | throw (CfiError)

Change harmonic parameters of the object.

Parameters:

  | harmonicModel | model data.

References EECFI::CfiError::addMsg().

void EECFI::InstrTransId::setMatrix | ( | const MatrixModel & | matrixModel | ) | throw (CfiError)

Change matrix model.

Parameters:

  | matrixModel | Matrix model data.

References EECFI::CfiError::addMsg().

void EECFI::InstrTransId::setOffset | ( | const double | offset[3] | ) | throw (CfiError)

Change Instrument frame origin position vector (Satellite attitude frame).

Parameters:

  | offset | Instrument frame origin position vector - Satellite attitude frame- [m].

References EECFI::CfiError::addMsg().